#include <stdio.h>
#include <stdlib.h>
#include "Graphics.h"

class IMG{
public:
	int width;
	int height;
	int colorDepth;
	unsigned char* red;
	unsigned char* green;
	unsigned char* blue;
};

void readLine(FILE* in, char *text)
{
	int t=0;
	do{
		text[t++]   = fgetc(in); 
		text[t] = 0;
	}while(text[t-1]!=10 && text[t-1]!=13 && !feof(in) && t<999);		
}
IMG readImage(char* name)
{
	char text[1000];
	IMG img;
	int numPixelValues = 0;

	unsigned char r,g,b;
	FILE* in = fopen(name,"rb");
	if (in!=NULL){
		// quick & dirty --- read two lines
		readLine(in,text);
		printf("%s\n",text);
		readLine(in,text);
		printf("%s\n",text);
		readLine(in,text);
		printf("%s\n",text);

		img.width = atoi(text);
		int i;
		for (i=0; text[i]!=' ' && text[i]!='	'; i++){
		}
		img.height = atoi(&text[i]);
		printf("width = %d. height = %d\n",img.width,img.height);
		numPixelValues = img.width*img.height;

		img.red = (unsigned char*)malloc(numPixelValues);
		img.green = (unsigned char*)malloc(numPixelValues);
		img.blue = (unsigned char*)malloc(numPixelValues);

		readLine(in,text);
		printf("%s\n",text);
		img.colorDepth = atoi(text);

		// now read pixel information
		for (int t=0; t<numPixelValues && !feof(in); t++){
			img.red[t] = fgetc(in);
			img.green[t] = fgetc(in);
			img.blue[t] = fgetc(in);
		}
		fclose(in);
	}
	else{
		printf("Could not open File:%s\n",name);
	}
	return img;
}
void writeImage(char* name, IMG img)
{
	FILE* out = fopen(name,"wb");
	if (out!=NULL){
		fprintf(out,"P6\n%d %d %d\n",img.width, img.height, img.colorDepth);
		for (int t=0;t<img.height*img.width;t++){
			fputc(img.red[t],out);
			fputc(img.green[t],out);
			fputc(img.blue[t],out);
		}
	}
	fflush(out);
}

#define pixel(x,y) (y*img[0].width + x)

int main(int argc, char**argv){

	IMG img[3];
	img[0] = readImage((char*)"Kugeln.ppm");

	openWindow((char*)"ImageFilter",1000,500);

	for (int y = 1; y< img[0].height-1; y++){
		for (int x = 1; x< img[0].width-1; x++){
			int red = (int)img[0].red[pixel(x,y)];
			int green = (int)img[0].green[pixel(x,y)];
			int blue = (int)img[0].blue[pixel(x,y)];

			setColor(red,green,blue);	
			drawPixel(x,y);
		}
	}	

	//int rr = 150, gg = 0, bb = 0;
	int rmax = 224;
	int rmin = 188;

	int gmax = 215;
	int gmin = 129;

	int bmax = 133;
	int bmin = 1;

	for (int y = 1; y< img[0].height-1; y++){
		for (int x = 1; x< img[0].width-1; x++){
			int red = (int)img[0].red[pixel(x,y)];
			int green = (int)img[0].green[pixel(x,y)];
			int blue = (int)img[0].blue[pixel(x,y)];

			//int euklDist = (red-rr)*(red-rr) + (green-gg)*(green-gg) + (blue-bb)*(blue-bb);
			//if (euklDist>6000){
			if (red>rmax || red<rmin || green>gmax || green<gmin || blue>bmax || blue<bmin){
				red=0;green=0;blue=0;
			}else{
				setColor(255,255,255);	
				drawPixel(x+500,y);
			}
		}
	}

	/*
		char text[1000];
		sprintf(text,"afterConvLayer%d.ppm",t+1);
		writeImage((char*)text,img[1]);
	*/
	
	//writeImage((char*)"TestFiltered.ppm",img[2],img[1]);

	while(1) {

		printf("Mousex = %d, mousey = %d\n, red = %d, green = %d, blue = %d\n",mousex,mousey,img[0].red[pixel(mousex,mousey)],img[0].green[pixel(mousex,mousey)],img[0].blue[pixel(mousex,mousey)]);
        // Wait for the user to press a character.
        char c = keyPressed();
        // Quit if it is the letter q.
        if(c=='q') break;
    }


}
